﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Documents.Reports;
using Infragistics.Documents.Reports.Report.Section;
using Infragistics.Documents.Reports.Report.Text;
using Infragistics.Documents.Reports.Graphics;
using System.Text.RegularExpressions;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = populateGrid();
            this.WebHierarchicalDataGrid1.DataSource = Session["GridData"];
            this.WebHierarchicalDataGrid1.DataBind();
        }
        else
        {
            this.WebHierarchicalDataGrid1.DataSource = Session["GridData"];
        }
    }

    public DataSet populateGrid()
    {
        DataSet ds = new DataSet();
        DataTable Parent = new DataTable();
        Parent.TableName = "Parent";
        DataTable Child = new DataTable();
        Child.TableName = "Child";

        Parent.Columns.Add("ID", typeof(System.Int32));
        Parent.Columns.Add("Name");
        Parent.Columns.Add("Test");

        DataColumn[] col = new DataColumn[1];
        col[0] = Parent.Columns["ID"];
        Parent.PrimaryKey = col;

        DataRow row = Parent.NewRow();
        row.SetField<int>("ID", 0);
        row.SetField<string>("Name", "Alice");
        row.SetField<string>("Test", "<a href='" + "http://www.google.com" + "' target='_blank'>" + "Google Search" + "</a> ");
        Parent.Rows.Add(row);

        row = Parent.NewRow();
        row.SetField<int>("ID", 1);
        row.SetField<String>("Name", "Bob");
        row.SetField<string>("Test", "<a href='" + "http://www.infragistics.com" + "' target='_blank'>" + "Infragistics controls" + "</a> ");
        Parent.Rows.Add(row);


        Child.Columns.Add("ChildID", typeof(System.Int32));
        Child.Columns.Add("ID", typeof(System.Int32));
        Child.Columns.Add("Address");
        Child.Columns.Add("Count", typeof(int));
        Child.Columns.Add("Other");


        DataColumn[] colChild = new DataColumn[1];
        colChild[0] = Child.Columns["ChildID"];
        colChild[0].AutoIncrement = true;
        colChild[0].AutoIncrementSeed = 1;
        colChild[0].DataType = typeof(int);
        Child.PrimaryKey = colChild;

        row = Child.NewRow();
        row.SetField<int>("ChildID", 0);
        row.SetField<int>("ID", 0);
        row.SetField<string>("Address", "Paris");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 5);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ChildID", 1);
        row.SetField<int>("ID", 1);
        row.SetField<string>("Address", "Rome");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 9);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ChildID", 2);
        row.SetField<int>("ID", 1);
        row.SetField<string>("Address", "London");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 2);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ChildID", 3);
        row.SetField<int>("ID", 0);
        row.SetField<string>("Address", "LosAngeles");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 9);
        Child.Rows.Add(row);

        ds.Tables.Add(Parent);
        ds.Tables.Add(Child);

        DataRelation relation = new DataRelation("IDRelation", Parent.Columns["ID"], Child.Columns["ID"]);
        ds.Relations.Add(relation);

        return ds;
    }

    protected void exportButton_Click(object sender, EventArgs e)
    {
        string fileName = HttpUtility.UrlEncode("WebHierarchicalDataGridExport");
        //fileName = fileName.Replace("+", "%20");
        fileName = HttpUtility.UrlDecode(fileName);
        this.dExporter.DownloadName = fileName;

        Infragistics.Documents.Reports.Report.Report report = new Infragistics.Documents.Reports.Report.Report();

        ((report.Preferences).PDF).Viewer.HideMenubar = true;
        ((report.Preferences).PDF).Viewer.HideToolbar = true;
        ((report.Preferences).PDF).Viewer.HideWindowUI = true;

        this.dExporter.Export(this.WebHierarchicalDataGrid1, report);
    }


    protected void dExporter_CellExporting(object sender, Infragistics.Web.UI.GridControls.DocumentCellExportingEventArgs e)
    {
        if (e.GridCell != null && e.GridCell.Column.Key == "Test")
        {
            //style for the hyperlink
            Infragistics.Documents.Reports.Report.Text.Style bluelink = new Infragistics.Documents.Reports.Report.Text.Style(new Font("Aria", 8, FontStyle.Underline), Brushes.Blue);
            //adds the text with the hyperlink 

            string reff = e.GridCell.Value.ToString();
            var regex = new Regex("<a [^>]*href=(?:'(?<href>.*?)')|(?:\"(?<href>.*?)\")", RegexOptions.IgnoreCase);
            var urls = regex.Matches(reff).OfType<Match>().Select(m => m.Groups["href"].Value).SingleOrDefault();

            e.ReportCellElement.AddText().AddContent(urls, bluelink, new Hyperlink(urls));
            //cancels the creation of the normal output
            //for this cell
            e.Cancel = true;
        }
    }
}